-- Advanced Programming, homework 3
-- by <YOUR NAME HERE>

module Main where 

import XMLTypes
import Play

------------------------------------------------------------------------------
-- A simple function for counting the number of speeches made by one given
-- character.  Provided for your reference.

countSpeeches :: String -> SimpleXML -> Int 
countSpeeches _ (PCDATA _) = 
  0 
countSpeeches name (Element "SPEAKER" [PCDATA s]) 
  | s == name = 1
  | otherwise = 0
countSpeeches name (Element _ nodelist) =
  foldl (\x y -> x + (countSpeeches name y)) 0 nodelist 

reportSpeeches :: String -> IO ()
reportSpeeches name = do
  putStr name 
  putStr " gets "
  putStr (show (countSpeeches name play)) 
  putStr " speeches in this play!\n"

------------------------------------------------------------------------------
-- PART I: Finite maps based on red-black trees

data Color = R | B
data FiniteMap a b = 
    E 
  | T Color (FiniteMap a b) (a,b) (FiniteMap a b)

emptyMap :: FiniteMap a b
emptyMap = E

lookupMap :: Ord a => a -> FiniteMap a b -> Maybe b
-- replace with something useful:
lookupMap = error "not implemented"
   
insertMap :: Ord a => a -> b -> FiniteMap a b -> FiniteMap a b
-- replace with something useful:
insertMap = error "not implemented"

mapToList :: FiniteMap a b -> [(a,b)]
mapToList E = []
mapToList (T _ a kv b) = mapToList a ++ [kv] ++ mapToList b

------------------------------------------------------------------------------
-- Part II: Counting all speeches in a play

countAllSpeeches :: SimpleXML -> FiniteMap String Integer
-- replace with something useful:
countAllSpeeches x = emptyMap    

dumpSpeeches :: FiniteMap String Integer -> String
dumpSpeeches m = 
  concat 
    (map (\(name,speeches) -> name ++ " " ++ show speeches ++ "\n") 
         (mapToList m))

------------------------------------------------------------------------------
-- PART III: Rendering an XML play as HTML

playToHTML :: SimpleXML -> String
playToHTML x = "not implemented"

------------------------------------------------------------------------------
-- Main program (do not change anything below this point)

firstDiff :: Eq a => [a] -> [a] -> Maybe ([a],[a])
firstDiff [] [] = Nothing
firstDiff (c:cs) (d:ds) 
     | c==d = firstDiff cs ds 
     | otherwise = Just (c:cs, d:ds)
firstDiff cs ds = Just (cs,ds)

testResults :: String -> String -> IO ()
testResults file1 file2 = do 
  f1 <- readFile file1
  f2 <- readFile file2
  case firstDiff f1 f2 of
    Nothing -> putStr "Success!\n"
    Just (cs,ds) -> do
      putStr "Different results: '"
      putStr (take 20 cs)
      putStr "' and '"
      putStr (take 20 ds)
      putStr "'\n"

main :: IO () 
main = 
  do reportSpeeches "THESEUS"
     putStr "Summarizing... "
     writeFile "speeches.txt" (dumpSpeeches (countAllSpeeches play))
     testResults "speeches.txt" "samplespeeches.txt"
     putStr "Converting... "
     writeFile "dream.html" (playToHTML play)
     testResults "dream.html" "sample.html"
